catch {TE::UTILS::te_msg TE_BD-0 INFO "This block design tcl-file was generate with Trenz Electronic GmbH Board Part:trenz.biz:te0950_a_35_2c:part0:1.0, FPGA: xc7a35tcsg324-2 at 2024-04-10T17:31:37."}

if { ![info exist TE::VERSION_CONTROL] } {
  namespace eval ::TE  {
    set ::TE::VERSION_CONTROL true
  }
}
################################################################
# Check if script is running in correct Vivado version.
################################################################
set scripts_vivado_version 2023.2
set current_vivado_version [version -short ]
if { [string first $scripts_vivado_version $current_vivado_version] == -1 &&  $TE::VERSION_CONTROL } {
   puts ""
   catch {common::send_msg_id "BD_TCL-109" "ERROR" "This script was generated using Vivado < $scripts_vivado_version> and is being run in < $current_vivado_version> of Vivado. Please run the script in Vivado < $scripts_vivado_version> then open the design in Vivado < $current_vivado_version>. Upgrade the design by running "Tools => Report => Report IP Status...", then run write_bd_tcl to create an updated script."}
 return 1
}

################################################################
# This is a generated script based on design: msys
#
# Though there are limitations about the generated script,
# the main purpose of this utility is to make learning
# IP Integrator Tcl commands easier.
################################################################

namespace eval _tcl {
proc get_script_folder {} {
   set script_path [file normalize [info script]]
   set script_folder [file dirname $script_path]
   return $script_folder
}
}
variable script_folder
set script_folder [_tcl::get_script_folder]

################################################################
# Check if script is running in correct Vivado version.
################################################################
set scripts_vivado_version 2023.2
set current_vivado_version [version -short]

if { [string first $scripts_vivado_version $current_vivado_version] == -1 } {
   puts ""
   common::send_gid_msg -ssname BD::TCL -id 2040 -severity "CRITICAL WARNING" "This script was generated using Vivado <$scripts_vivado_version> without IP versions in the create_bd_cell commands, but is now being run in <$current_vivado_version> of Vivado. There may have been changes to the IP between Vivado <$scripts_vivado_version> and <$current_vivado_version>, which could impact the functionality and configuration of the design."

}

################################################################
# START
################################################################

# To test this script, run the following commands from Vivado Tcl console:
# source msys_script.tcl

# If there is no project opened, this script will create a
# project, but make sure you do not have an existing project
# <./myproj/project_1.xpr> in the current working folder.

set list_projs [get_projects -quiet]
if { $list_projs eq "" } {
   create_project project_1 myproj -part xc7a35tcsg324-2
   set_property BOARD_PART trenz.biz:te0950_a_35_2c:part0:1.0 [current_project]
}


# CHANGE DESIGN NAME HERE
variable design_name
set design_name msys

# If you do not already have an existing IP Integrator design open,
# you can create a design using the following command:
#    create_bd_design $design_name

# Creating design if needed
set errMsg ""
set nRet 0

set cur_design [current_bd_design -quiet]
set list_cells [get_bd_cells -quiet]

if { ${design_name} eq "" } {
   # USE CASES:
   #    1) Design_name not set

   set errMsg "Please set the variable <design_name> to a non-empty value."
   set nRet 1

} elseif { ${cur_design} ne "" && ${list_cells} eq "" } {
   # USE CASES:
   #    2): Current design opened AND is empty AND names same.
   #    3): Current design opened AND is empty AND names diff; design_name NOT in project.
   #    4): Current design opened AND is empty AND names diff; design_name exists in project.

   if { $cur_design ne $design_name } {
      common::send_gid_msg -ssname BD::TCL -id 2001 -severity "INFO" "Changing value of <design_name> from <$design_name> to <$cur_design> since current design is empty."
      set design_name [get_property NAME $cur_design]
   }
   common::send_gid_msg -ssname BD::TCL -id 2002 -severity "INFO" "Constructing design in IPI design <$cur_design>..."

} elseif { ${cur_design} ne "" && $list_cells ne "" && $cur_design eq $design_name } {
   # USE CASES:
   #    5) Current design opened AND has components AND same names.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 1
} elseif { [get_files -quiet ${design_name}.bd] ne "" } {
   # USE CASES: 
   #    6) Current opened design, has components, but diff names, design_name exists in project.
   #    7) No opened design, design_name exists in project.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 2

} else {
   # USE CASES:
   #    8) No opened design, design_name not in project.
   #    9) Current opened design, has components, but diff names, design_name not in project.

   common::send_gid_msg -ssname BD::TCL -id 2003 -severity "INFO" "Currently there is no design <$design_name> in project, so creating one..."

   create_bd_design $design_name

   common::send_gid_msg -ssname BD::TCL -id 2004 -severity "INFO" "Making design <$design_name> as current_bd_design."
   current_bd_design $design_name

}

common::send_gid_msg -ssname BD::TCL -id 2005 -severity "INFO" "Currently the variable <design_name> is equal to \"$design_name\"."

if { $nRet != 0 } {
   catch {common::send_gid_msg -ssname BD::TCL -id 2006 -severity "ERROR" $errMsg}
   return $nRet
}

set bCheckIPsPassed 1
##################################################################
# CHECK IPs
##################################################################
set bCheckIPs 1
if { $bCheckIPs == 1 } {
   set list_check_ips "\ 
trenz.biz:user:iic_pca9548a:*\
xilinx.com:ip:axi_chip2chip:*\
xilinx.com:ip:axi_gpio:*\
xilinx.com:ip:smartconnect:*\
xilinx.com:ip:clk_wiz:*\
xilinx.com:ip:axi_timer:*\
xilinx.com:ip:proc_sys_reset:*\
xilinx.com:ip:util_ds_buf:*\
xilinx.com:ip:xlconcat:*\
xilinx.com:ip:xlslice:*\
trenz.biz:user:axi_reg32:*\
trenz.biz:user:labtools_fmeter:*\
"

   set list_ips_missing ""
   common::send_gid_msg -ssname BD::TCL -id 2011 -severity "INFO" "Checking if the following IPs exist in the project's IP catalog: $list_check_ips ."

   foreach ip_vlnv $list_check_ips {
      set ip_obj [get_ipdefs -all $ip_vlnv]
      if { $ip_obj eq "" } {
         lappend list_ips_missing $ip_vlnv
      }
   }

   if { $list_ips_missing ne "" } {
      catch {common::send_gid_msg -ssname BD::TCL -id 2012 -severity "ERROR" "The following IPs are not found in the IP Catalog:\n  $list_ips_missing\n\nResolution: Please add the repository containing the IP(s) to the project." }
      set bCheckIPsPassed 0
   }

}

if { $bCheckIPsPassed != 1 } {
  common::send_gid_msg -ssname BD::TCL -id 2023 -severity "WARNING" "Will not continue with creation of design due to the error(s) above."
  return 3
}

##################################################################
# DESIGN PROCs
##################################################################


# Hierarchical cell: fmc
proc create_hier_cell_fmc { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_gid_msg -ssname BD::TCL -id 2092 -severity "ERROR" "create_hier_cell_fmc() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_gid_msg -ssname BD::TCL -id 2090 -severity "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_gid_msg -ssname BD::TCL -id 2091 -severity "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:interface:aximm_rtl:1.0 S_AXI

  create_bd_intf_pin -mode Slave -vlnv xilinx.com:interface:aximm_rtl:1.0 S_AXI1


  # Create pins
  create_bd_pin -dir IO -from 33 -to 0 LA_P
  create_bd_pin -dir IO -from 33 -to 0 LA_N
  create_bd_pin -dir I -type clk s_axi_aclk
  create_bd_pin -dir I C2C_RST
  create_bd_pin -dir I -type clk A_USR_CLK25M
  create_bd_pin -dir I -from 3 -to 0 CLK_M2C_P
  create_bd_pin -dir I -from 3 -to 0 CLK_M2C_N

  # Create instance: util_ds_buf_0, and set properties
  set util_ds_buf_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf util_ds_buf_0 ]
  set_property -dict [list \
    CONFIG.C_BUF_TYPE {IOBUFDS} \
    CONFIG.C_SIZE {34} \
  ] $util_ds_buf_0


  # Create instance: xlconcat_0, and set properties
  set xlconcat_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat xlconcat_0 ]

  # Create instance: xlslice_0, and set properties
  set xlslice_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice xlslice_0 ]
  set_property -dict [list \
    CONFIG.DIN_FROM {31} \
    CONFIG.DIN_WIDTH {34} \
  ] $xlslice_0


  # Create instance: xlslice_1, and set properties
  set xlslice_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlslice xlslice_1 ]
  set_property -dict [list \
    CONFIG.DIN_FROM {33} \
    CONFIG.DIN_TO {32} \
    CONFIG.DIN_WIDTH {34} \
  ] $xlslice_1


  # Create instance: xlconcat_1, and set properties
  set xlconcat_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat xlconcat_1 ]

  # Create instance: axi_gpio_1, and set properties
  set axi_gpio_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_gpio axi_gpio_1 ]
  set_property -dict [list \
    CONFIG.C_GPIO2_WIDTH {2} \
    CONFIG.C_IS_DUAL {1} \
  ] $axi_gpio_1


  # Create instance: axi_reg32_0, and set properties
  set axi_reg32_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:axi_reg32 axi_reg32_0 ]
  set_property -dict [list \
    CONFIG.C_NUM_RO_REG {4} \
    CONFIG.C_NUM_WR_REG {0} \
    CONFIG.C_WR_READABLE {true} \
  ] $axi_reg32_0


  # Create instance: labtools_fmeter_0, and set properties
  set labtools_fmeter_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:labtools_fmeter labtools_fmeter_0 ]
  set_property CONFIG.C_REFCLK_HZ {25000000} $labtools_fmeter_0


  # Create instance: util_ds_buf_2, and set properties
  set util_ds_buf_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf util_ds_buf_2 ]
  set_property CONFIG.C_SIZE {4} $util_ds_buf_2


  # Create interface connections
  connect_bd_intf_net -intf_net smartconnect_0_M01_AXI [get_bd_intf_pins S_AXI] [get_bd_intf_pins axi_gpio_1/S_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M02_AXI [get_bd_intf_pins S_AXI1] [get_bd_intf_pins axi_reg32_0/S_AXI]

  # Create port connections
  connect_bd_net -net A_USR_CLK25M_1 [get_bd_pins A_USR_CLK25M] [get_bd_pins labtools_fmeter_0/refclk]
  connect_bd_net -net C2C_RST_1 [get_bd_pins C2C_RST] [get_bd_pins axi_reg32_0/s_axi_aresetn] [get_bd_pins axi_gpio_1/s_axi_aresetn]
  connect_bd_net -net CLK_M2C_N_1 [get_bd_pins CLK_M2C_N] [get_bd_pins util_ds_buf_2/IBUF_DS_N]
  connect_bd_net -net CLK_M2C_P_1 [get_bd_pins CLK_M2C_P] [get_bd_pins util_ds_buf_2/IBUF_DS_P]
  connect_bd_net -net Net [get_bd_pins LA_P] [get_bd_pins util_ds_buf_0/IOBUF_DS_P]
  connect_bd_net -net Net1 [get_bd_pins LA_N] [get_bd_pins util_ds_buf_0/IOBUF_DS_N]
  connect_bd_net -net axi_gpio_1_gpio2_io_o [get_bd_pins axi_gpio_1/gpio2_io_o] [get_bd_pins xlconcat_0/In1]
  connect_bd_net -net axi_gpio_1_gpio2_io_t [get_bd_pins axi_gpio_1/gpio2_io_t] [get_bd_pins xlconcat_1/In1]
  connect_bd_net -net axi_gpio_1_gpio_io_o [get_bd_pins axi_gpio_1/gpio_io_o] [get_bd_pins xlconcat_0/In0]
  connect_bd_net -net axi_gpio_1_gpio_io_t [get_bd_pins axi_gpio_1/gpio_io_t] [get_bd_pins xlconcat_1/In0]
  connect_bd_net -net clk_wiz_0_clk_out1 [get_bd_pins s_axi_aclk] [get_bd_pins axi_reg32_0/s_axi_aclk] [get_bd_pins axi_gpio_1/s_axi_aclk]
  connect_bd_net -net labtools_fmeter_0_F0 [get_bd_pins labtools_fmeter_0/F0] [get_bd_pins axi_reg32_0/RR0]
  connect_bd_net -net labtools_fmeter_0_F1 [get_bd_pins labtools_fmeter_0/F1] [get_bd_pins axi_reg32_0/RR1]
  connect_bd_net -net labtools_fmeter_0_F2 [get_bd_pins labtools_fmeter_0/F2] [get_bd_pins axi_reg32_0/RR2]
  connect_bd_net -net labtools_fmeter_0_F3 [get_bd_pins labtools_fmeter_0/F3] [get_bd_pins axi_reg32_0/RR3]
  connect_bd_net -net util_ds_buf_0_IOBUF_IO_O [get_bd_pins util_ds_buf_0/IOBUF_IO_O] [get_bd_pins xlslice_0/Din] [get_bd_pins xlslice_1/Din]
  connect_bd_net -net util_ds_buf_2_IBUF_OUT [get_bd_pins util_ds_buf_2/IBUF_OUT] [get_bd_pins labtools_fmeter_0/fin]
  connect_bd_net -net xlconcat_0_dout [get_bd_pins xlconcat_0/dout] [get_bd_pins util_ds_buf_0/IOBUF_IO_I]
  connect_bd_net -net xlconcat_1_dout [get_bd_pins xlconcat_1/dout] [get_bd_pins util_ds_buf_0/IOBUF_IO_T]
  connect_bd_net -net xlslice_0_Dout [get_bd_pins xlslice_0/Dout] [get_bd_pins axi_gpio_1/gpio_io_i]
  connect_bd_net -net xlslice_1_Dout [get_bd_pins xlslice_1/Dout] [get_bd_pins axi_gpio_1/gpio2_io_i]

  # Restore current instance
  current_bd_instance $oldCurInst
}


# Procedure to create entire design; Provide argument to make
# procedure reusable. If parentCell is "", will use root.
proc create_root_design { parentCell } {

  variable script_folder
  variable design_name

  if { $parentCell eq "" } {
     set parentCell [get_bd_cells /]
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_gid_msg -ssname BD::TCL -id 2090 -severity "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_gid_msg -ssname BD::TCL -id 2091 -severity "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj


  # Create interface ports
  set C_HS1_SMB_IIC [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:iic_rtl:1.0 C_HS1_SMB_IIC ]

  set C_HS2_SMB_IIC [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:iic_rtl:1.0 C_HS2_SMB_IIC ]

  set FMC_IIC [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:iic_rtl:1.0 FMC_IIC ]

  set QSFP_IIC [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:iic_rtl:1.0 QSFP_IIC ]

  set USR [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:gpio_rtl:1.0 USR ]

  set C_HS1 [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:gpio_rtl:1.0 C_HS1 ]

  set C_HS2 [ create_bd_intf_port -mode Master -vlnv xilinx.com:interface:gpio_rtl:1.0 C_HS2 ]


  # Create ports
  set A_USR_CLK25M [ create_bd_port -dir I -type clk -freq_hz 25000000 A_USR_CLK25M ]
  set IIC_SCL_I [ create_bd_port -dir I -type data IIC_SCL_I ]
  set IIC_SDA_I [ create_bd_port -dir I IIC_SDA_I ]
  set IIC_SDA_O [ create_bd_port -dir O IIC_SDA_O ]
  set CLK_M2C_N [ create_bd_port -dir I -from 3 -to 0 CLK_M2C_N ]
  set CLK_M2C_P [ create_bd_port -dir I -from 3 -to 0 CLK_M2C_P ]
  set FAN_PWM [ create_bd_port -dir O -from 0 -to 0 FAN_PWM ]
  set FAN_TACHO [ create_bd_port -dir I FAN_TACHO ]
  set C2C_RX [ create_bd_port -dir I -from 8 -to 0 C2C_RX ]
  set C2C_TX [ create_bd_port -dir O -from 8 -to 0 C2C_TX ]
  set C2C_RX_CLK [ create_bd_port -dir I -type clk -freq_hz 100000000 C2C_RX_CLK ]
  set C2C_TX_CLK [ create_bd_port -dir O -type clk C2C_TX_CLK ]
  set C2C_RST [ create_bd_port -dir I C2C_RST ]
  set LA_N [ create_bd_port -dir IO -from 33 -to 0 LA_N ]
  set LA_P [ create_bd_port -dir IO -from 33 -to 0 LA_P ]

  # Create instance: iic_pca9548a_0, and set properties
  set iic_pca9548a_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:iic_pca9548a iic_pca9548a_0 ]

  # Create instance: axi_chip2chip_0, and set properties
  set axi_chip2chip_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_chip2chip axi_chip2chip_0 ]
  set_property -dict [list \
    CONFIG.C_INCLUDE_AXILITE {0} \
    CONFIG.C_INTERFACE_MODE {2} \
    CONFIG.C_MASTER_FPGA {0} \
    CONFIG.C_M_AXI_ID_WIDTH {0} \
    CONFIG.C_M_AXI_WUSER_WIDTH {0} \
  ] $axi_chip2chip_0


  # Create instance: axi_gpio_0, and set properties
  set axi_gpio_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_gpio axi_gpio_0 ]
  set_property CONFIG.C_GPIO_WIDTH {3} $axi_gpio_0


  # Create instance: smartconnect_0, and set properties
  set smartconnect_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:smartconnect smartconnect_0 ]
  set_property -dict [list \
    CONFIG.NUM_MI {6} \
    CONFIG.NUM_SI {1} \
  ] $smartconnect_0


  # Create instance: clk_wiz_0, and set properties
  set clk_wiz_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:clk_wiz clk_wiz_0 ]
  set_property -dict [list \
    CONFIG.CLKOUT1_DRIVES {BUFGCE} \
    CONFIG.CLKOUT2_DRIVES {BUFGCE} \
    CONFIG.CLKOUT2_JITTER {206.578} \
    CONFIG.CLKOUT2_PHASE_ERROR {237.727} \
    CONFIG.CLKOUT2_REQUESTED_OUT_FREQ {200.000} \
    CONFIG.CLKOUT2_USED {true} \
    CONFIG.CLKOUT3_DRIVES {BUFGCE} \
    CONFIG.CLKOUT4_DRIVES {BUFGCE} \
    CONFIG.CLKOUT5_DRIVES {BUFGCE} \
    CONFIG.CLKOUT6_DRIVES {BUFGCE} \
    CONFIG.CLKOUT7_DRIVES {BUFGCE} \
    CONFIG.ENABLE_CLOCK_MONITOR {false} \
    CONFIG.FEEDBACK_SOURCE {FDBK_AUTO} \
    CONFIG.MMCM_CLKOUT1_DIVIDE {5} \
    CONFIG.NUM_OUT_CLKS {2} \
    CONFIG.PRIMITIVE {MMCM} \
    CONFIG.USE_SAFE_CLOCK_STARTUP {true} \
  ] $clk_wiz_0


  # Create instance: fmc
  create_hier_cell_fmc [current_bd_instance .] fmc

  # Create instance: axi_c_hs2, and set properties
  set axi_c_hs2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_gpio axi_c_hs2 ]
  set_property CONFIG.C_GPIO_WIDTH {2} $axi_c_hs2


  # Create instance: axi_c_hs1, and set properties
  set axi_c_hs1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_gpio axi_c_hs1 ]
  set_property CONFIG.C_GPIO_WIDTH {2} $axi_c_hs1


  # Create instance: axi_timer_0, and set properties
  set axi_timer_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_timer axi_timer_0 ]
  set_property -dict [list \
    CONFIG.COUNT_WIDTH {32} \
    CONFIG.enable_timer2 {1} \
  ] $axi_timer_0


  # Create instance: proc_sys_reset_0, and set properties
  set proc_sys_reset_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset proc_sys_reset_0 ]

  # Create interface connections
  connect_bd_intf_net -intf_net axi_c_hs1_GPIO [get_bd_intf_ports C_HS1] [get_bd_intf_pins axi_c_hs1/GPIO]
  connect_bd_intf_net -intf_net axi_c_hs2_GPIO [get_bd_intf_ports C_HS2] [get_bd_intf_pins axi_c_hs2/GPIO]
  connect_bd_intf_net -intf_net axi_chip2chip_0_m_axi [get_bd_intf_pins axi_chip2chip_0/m_axi] [get_bd_intf_pins smartconnect_0/S00_AXI]
  connect_bd_intf_net -intf_net axi_gpio_0_GPIO [get_bd_intf_ports USR] [get_bd_intf_pins axi_gpio_0/GPIO]
  connect_bd_intf_net -intf_net iic_pca9548a_0_M0_IIC [get_bd_intf_ports C_HS1_SMB_IIC] [get_bd_intf_pins iic_pca9548a_0/M0_IIC]
  connect_bd_intf_net -intf_net iic_pca9548a_0_M1_IIC [get_bd_intf_ports C_HS2_SMB_IIC] [get_bd_intf_pins iic_pca9548a_0/M1_IIC]
  connect_bd_intf_net -intf_net iic_pca9548a_0_M2_IIC [get_bd_intf_ports QSFP_IIC] [get_bd_intf_pins iic_pca9548a_0/M2_IIC]
  connect_bd_intf_net -intf_net iic_pca9548a_0_M3_IIC [get_bd_intf_ports FMC_IIC] [get_bd_intf_pins iic_pca9548a_0/M3_IIC]
  connect_bd_intf_net -intf_net smartconnect_0_M00_AXI [get_bd_intf_pins smartconnect_0/M00_AXI] [get_bd_intf_pins axi_gpio_0/S_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M01_AXI [get_bd_intf_pins smartconnect_0/M01_AXI] [get_bd_intf_pins fmc/S_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M02_AXI [get_bd_intf_pins fmc/S_AXI1] [get_bd_intf_pins smartconnect_0/M02_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M03_AXI [get_bd_intf_pins smartconnect_0/M03_AXI] [get_bd_intf_pins axi_c_hs1/S_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M04_AXI [get_bd_intf_pins smartconnect_0/M04_AXI] [get_bd_intf_pins axi_c_hs2/S_AXI]
  connect_bd_intf_net -intf_net smartconnect_0_M05_AXI [get_bd_intf_pins smartconnect_0/M05_AXI] [get_bd_intf_pins axi_timer_0/S_AXI]

  # Create port connections
  connect_bd_net -net A_USR_CLK25M_1 [get_bd_ports A_USR_CLK25M] [get_bd_pins clk_wiz_0/clk_in1] [get_bd_pins fmc/A_USR_CLK25M]
  connect_bd_net -net C2C_RST_1 [get_bd_ports C2C_RST] [get_bd_pins axi_chip2chip_0/m_aresetn] [get_bd_pins smartconnect_0/aresetn] [get_bd_pins axi_gpio_0/s_axi_aresetn] [get_bd_pins fmc/C2C_RST] [get_bd_pins axi_c_hs1/s_axi_aresetn] [get_bd_pins axi_c_hs2/s_axi_aresetn] [get_bd_pins axi_timer_0/s_axi_aresetn] [get_bd_pins proc_sys_reset_0/ext_reset_in]
  connect_bd_net -net C2C_RX_1 [get_bd_ports C2C_RX] [get_bd_pins axi_chip2chip_0/axi_c2c_selio_rx_data_in]
  connect_bd_net -net C2C_RX_CLK_1 [get_bd_ports C2C_RX_CLK] [get_bd_pins axi_chip2chip_0/axi_c2c_selio_rx_clk_in]
  connect_bd_net -net CLK_M2C_N_1 [get_bd_ports CLK_M2C_N] [get_bd_pins fmc/CLK_M2C_N]
  connect_bd_net -net CLK_M2C_P_1 [get_bd_ports CLK_M2C_P] [get_bd_pins fmc/CLK_M2C_P]
  connect_bd_net -net IIC_SCL_I_1 [get_bd_ports IIC_SCL_I] [get_bd_pins iic_pca9548a_0/s_scl_o] [get_bd_pins iic_pca9548a_0/s_scl_t]
  connect_bd_net -net IIC_SDA_I_1 [get_bd_ports IIC_SDA_I] [get_bd_pins iic_pca9548a_0/s_sda_o] [get_bd_pins iic_pca9548a_0/s_sda_t]
  connect_bd_net -net Net [get_bd_ports LA_P] [get_bd_pins fmc/LA_P]
  connect_bd_net -net Net1 [get_bd_ports LA_N] [get_bd_pins fmc/LA_N]
  connect_bd_net -net axi_chip2chip_0_axi_c2c_selio_tx_clk_out [get_bd_pins axi_chip2chip_0/axi_c2c_selio_tx_clk_out] [get_bd_ports C2C_TX_CLK]
  connect_bd_net -net axi_chip2chip_0_axi_c2c_selio_tx_data_out [get_bd_pins axi_chip2chip_0/axi_c2c_selio_tx_data_out] [get_bd_ports C2C_TX]
  connect_bd_net -net axi_timer_0_pwm0 [get_bd_pins axi_timer_0/pwm0] [get_bd_ports FAN_PWM]
  connect_bd_net -net clk_wiz_0_clk_out1 [get_bd_pins clk_wiz_0/clk_out1] [get_bd_pins smartconnect_0/aclk] [get_bd_pins axi_gpio_0/s_axi_aclk] [get_bd_pins axi_chip2chip_0/m_aclk] [get_bd_pins fmc/s_axi_aclk] [get_bd_pins axi_c_hs1/s_axi_aclk] [get_bd_pins axi_c_hs2/s_axi_aclk] [get_bd_pins axi_timer_0/s_axi_aclk] [get_bd_pins proc_sys_reset_0/slowest_sync_clk]
  connect_bd_net -net clk_wiz_0_clk_out2 [get_bd_pins clk_wiz_0/clk_out2] [get_bd_pins axi_chip2chip_0/idelay_ref_clk] [get_bd_pins iic_pca9548a_0/clk_in]
  connect_bd_net -net iic_pca9548a_0_s_sda_i [get_bd_pins iic_pca9548a_0/s_sda_i] [get_bd_ports IIC_SDA_O]
  connect_bd_net -net proc_sys_reset_0_peripheral_aresetn [get_bd_pins proc_sys_reset_0/peripheral_aresetn] [get_bd_pins iic_pca9548a_0/rst_n]

  # Create address segments
  assign_bd_address -offset 0xA80C0000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs axi_c_hs1/S_AXI/Reg] -force
  assign_bd_address -offset 0xA8100000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs axi_c_hs2/S_AXI/Reg] -force
  assign_bd_address -offset 0xA8080000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs axi_gpio_0/S_AXI/Reg] -force
  assign_bd_address -offset 0xA8000000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs fmc/axi_gpio_1/S_AXI/Reg] -force
  assign_bd_address -offset 0xA8040000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs fmc/axi_reg32_0/S_AXI/S_AXI_reg] -force
  assign_bd_address -offset 0xA8140000 -range 0x00010000 -target_address_space [get_bd_addr_spaces axi_chip2chip_0/MAXI] [get_bd_addr_segs axi_timer_0/S_AXI/Reg] -force


  # Restore current instance
  current_bd_instance $oldCurInst

  validate_bd_design
  save_bd_design
}
# End of create_root_design()


##################################################################
# MAIN FLOW
##################################################################

create_root_design ""



